﻿
  Structure DrawObject
    Pathtype.s
    Colour.i
    Trans.i
    Text.s
    X1.f
    Y1.f
    X2.f
    Y2.f
    X3.f
    Y3.f
    X4.f
    Y4.f
    RadiusX.f
    RadiusY.f
    Angle1.i
    Angle2.i
    Points.i
    Rotation.i
    RX.f
    RY.f
    Closed.i
    Width.f
    Filled.i
    Rounded.i
    Stroke.i
    Dash.i
    DashFactor.d
    Dot.i
    DotFactor.d
    LeftRight.i
    Font.s
  EndStructure

Global NewList Elements.DrawObject()

Global NumberOfElements.i

Global winDVG.i,cnvDraw.i,btnSelect.i,txtScale.i,strScale.i,chkEnabled.i,txtEnabled.i,btnExit.i

Global IconFile.s,Size.i,Enabled.i

  Procedure.i ConvertToGrey(Colour.i)
    
    #DefaultGrey = 100
  
    Define cRed.d,cGreen.d,cBlue.d,cAlpha.d
  
    ;Greyscale
    cRed = Red(Colour) * 0.3
    cGreen = Green(Colour) * 0.6
    cBlue = Blue(Colour) * 0.1
    cAlpha = Alpha(Colour) 
    cConvert = (cRed + cGreen + cBlue)
    If cConvert = 0
      cConvert = #DefaultGrey
    EndIf 

    ;Show greyscale
    rColour = RGBA(cConvert,cConvert,cConvert,cAlpha)

    ProcedureReturn rColour
  
  EndProcedure

  Procedure AddToElement(Element.s)
  
    Define Attrib.s
 
    Element = StringField(Element,2,"(")
  
    AddElement(Elements())

    Element = Right(Element,Len(Element) - FindString(Element,":") - 1)

    For iLoop = 1 To CountString(Element,Chr(2))
  
    Attrib = StringField(Element,iLoop,Chr(2))
  
    Select StringField(Attrib,1,"=")
      
      Case "Type"
      
        Elements()\Pathtype = StringField(Attrib,2,"=")
      
      Case "Colour"
      
        Elements()\Colour = Val(StringField(Attrib,2,"="))
      
      Case "Text"

        Elements()\Text = StringField(Attrib,2,"=")
      
      Case "X1"
      
        Elements()\X1 = ValF(StringField(Attrib,2,"=") ) 
      
      Case "Y1"
      
        elements()\Y1 = ValF(StringField(Attrib,2,"="))  
      
      Case "X2"
      
        Elements()\X2 = ValF(StringField(Attrib,2,"=")  )

      Case "Y2"
      
        Elements()\Y2 = ValF(StringField(Attrib,2,"=") ) 
   
      Case "X3"
      
        Elements()\X3 = ValF(StringField(Attrib,2,"=") ) 
  
      Case "Y3"
      
        Elements()\Y3 = ValF(StringField(Attrib,2,"=") ) 

      Case "X4"
      
        Elements()\X4 = ValF(StringField(Attrib,2,"=") )     

      Case "Y4"
      
       Elements()\Y4 = ValF(StringField(Attrib,2,"=") )       
      
      Case "RadiusX"
     
        Elements()\RadiusX = ValF(StringField(Attrib,2,"=") )

      Case "RadiusY"
      
        Elements()\RadiusY = ValF(StringField(Attrib,2,"=") )
 
      Case "Angle1"
      
        Elements()\Angle1 = Val(StringField(Attrib,2,"=") )

      Case "Angle2"
      
        Elements()\Angle2 = Val(StringField(Attrib,2,"=") )

      Case "Points"
      
        Elements()\Points = Val(StringField(Attrib,2,"=") )
     
      Case "Rotation"
      
        Elements()\Rotation = Val(StringField(Attrib,2,"=") )     

      Case "RX"
       
        Elements()\RX = Val(StringField(Attrib,2,"=") )         
       
      Case "RY"
       
        Elements()\RY = Val(StringField(Attrib,2,"=") )       

      Case "Closed"
       
        Elements()\Closed = Val(StringField(Attrib,2,"=") )     
   
      Case "Width"
       
        Elements()\Width = ValF(StringField(Attrib,2,"=") )
 
      Case "Filled"
       
        Elements()\Filled = Val(StringField(Attrib,2,"="))
   
      Case "Rounded"
      
        Elements()\Rounded = Val(StringField(Attrib,2,"="))
 
      Case "Stroke"
      
        Elements()\Stroke = Val(StringField(Attrib,2,"="))
 
      Case "Dash"
      
        Elements()\Dash = Val(StringField(Attrib,2,"="))
  
      Case "DashFactor"
      
        Elements()\DashFactor = Val(StringField(Attrib,2,"="))
 
      Case "Dot"
       
        Elements()\Dot = Val(StringField(Attrib,2,"="))
 
      Case "DotFactor"
      
        Elements()\DotFactor  = Val(StringField(Attrib,2,"="))

    EndSelect

  Next

EndProcedure
  
 Procedure ReadAttributes(*CurrentNode, CurrentSublevel)
   
   Define CurrentNode.s
   
   
  If XMLNodeType(*CurrentNode) = #PB_XML_Normal

    CurrentNode = GetXMLNodeName(*CurrentNode) + " (Attributes: "
        
    If ExamineXMLAttributes(*CurrentNode)
      While NextXMLAttribute(*CurrentNode)
        CurrentNode + XMLAttributeName(*CurrentNode) + "="  + XMLAttributeValue(*CurrentNode)  + Chr(2)
      Wend
    EndIf
    
    CurrentNode + ")"
    
    If FindString(CurrentNode,"Element") > 0

    AddToElement(CurrentNode)
    
  EndIf
  
    *ChildNode = ChildXMLNode(*CurrentNode)

    While *ChildNode <> 0
      ReadAttributes(*ChildNode, CurrentSublevel + 1)      
      *ChildNode = NextXMLNode(*ChildNode)
    Wend        
  
  EndIf
 
EndProcedure 
  
Procedure ReadImageFile(FileName.s)
  
  Define XML.i
  
  XML = LoadXML(#PB_Any, FileName)

  If XMLStatus(XML) <> #PB_XML_Success
    Message$ = "Error in the XML file:" + Chr(13)
    Message$ + "Message: " + XMLError(XML) + Chr(13)
    Message$ + "Line: " + Str(XMLErrorLine(XML)) + "   Character: " + Str(XMLErrorPosition(XML))
    MessageRequester("Error", Message$)
  EndIf
  
  ClearList(Elements())
  
  *MainNode = MainXMLNode(XML)      
  If *MainNode
    ReadAttributes(*MainNode, 0)
  EndIf
   
  NumberOfElements = ListSize(Elements())
  
EndProcedure

Procedure FinishPath(*Element.DrawObject,Scale.d)
    
  If *Element\Filled = #True
    If *Element\Rounded = #True
      FillPath(#PB_Path_Preserve )
      If *Element\Width > 0 
        StrokePath(*Element\Width * Scale, #PB_Path_RoundEnd|#PB_Path_RoundCorner)
      EndIf
    Else
      FillPath(#PB_Path_Preserve )
      If *Element\Width > 0    
        StrokePath(*Element\Width * Scale) 
      EndIf
    
    EndIf
  Else
    If *Element\Rounded  = #True
      If *Element\Dash = #True
        DashPath(*Element\Width * Scale,*Element\Width * Scale * *Element\DashFactor,#PB_Path_RoundEnd|#PB_Path_RoundCorner)
      ElseIf *Element\Dot = #True
        DotPath(*Element\width * Scale,*Element\width * Scale * *Element\DotFactor,#PB_Path_RoundEnd|#PB_Path_RoundCorner)
      ElseIf *Element\Dash = #True
        DashPath(*Element\Width* Scale,*Element\Width * Scale * *Element\DashFactor,#PB_Path_RoundEnd|#PB_Path_RoundCorner)
      Else
        StrokePath(*Element\Width * Scale, #PB_Path_RoundEnd|#PB_Path_RoundCorner) 
      EndIf
    Else
      If *Element\Dash = #True
        DashPath(*Element\Width * Scale,*Element\Width * Scale * *Element\DashFactor)
      ElseIf *Element\Dot = #True
        DotPath(*Element\width * Scale,*Element\width * Scale * *Element\DotFactor)
      Else
        If *Element\Width > 0 
          StrokePath(*Element\Width * Scale) 
        EndIf
          
      EndIf
    EndIf     
  EndIf 
    
EndProcedure

Procedure.s ScalePathSegments(Path.s,Scale.d)
  
  Define ReturnPath.s
  
  For iLoop = 1 To CountString(Path," ") + 1
    
    Select StringField(Path,iLoop," ")
        
      Case "M" ;Move Cursor
        
        ReturnPath = ReturnPath + "M "
        
        ;The Next Two are X and Y
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "
        
      Case "C"
        
        ReturnPath = ReturnPath + "C "
        
         ;The Next Six are curve points
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "        
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "          
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "          
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "       
        
      Case "L" ;Line
        
         ReturnPath = ReturnPath + "L "
        
        ;The Next Two are X and Y
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "
        iLoop = iLoop + 1
        ReturnPath = ReturnPath + StrF(ValF(StringField(Path,iLoop," ")) * Scale) + " "      
        
      Case "Z" ;Close Path
        
        ReturnPath = ReturnPath + "Z"

      EndSelect  
      
  Next iLoop

  ProcedureReturn ReturnPath
   
EndProcedure

  Procedure DrawPath(*Element.DrawObject,Scale.d,Enabled.i = #True)
      
    Define ThisPath.s
    Define DrawColour.i,DrawTrans.i
    
    If Enabled = #True
       DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)      
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 

    DrawTrans = Alpha(*Element\Colour)
    
    VectorSourceColor(DrawColour)

    ThisPath = ScalePathSegments(*Element\Text,Scale)

    AddPathSegments(ThisPath)

    FinishPath(*Element.DrawObject,Scale.d)

  EndProcedure
  
  Procedure DrawArc(*Element.DrawObject,Scale.d,Enabled.i = #True)
     
    Define DrawColour.i,DrawTrans.i
    
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)  
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 
    DrawTrans = Alpha(*Element\Colour)
    VectorSourceColor(DrawColour)
    
    BeginVectorLayer(DrawTrans)

    If *Element\Closed = #True   
      MovePathCursor(*Element\X1 * Scale, *Element\Y1 * Scale)
      AddPathCircle(*Element\X1 * Scale, *Element\Y1 * Scale, *Element\RadiusX * Scale, *Element\Angle1, *Element\Angle2, #PB_Path_Connected) 
      ClosePath()
    Else
      AddPathCircle(*Element\X1 * Scale, *Element\Y1 * Scale, *Element\RadiusX * Scale, *Element\Angle1, *Element\Angle2) 
    EndIf
    
    FinishPath(*Element.DrawObject,Scale)
 
    EndVectorLayer()
    
  EndProcedure 
  
  Procedure DrawBox(*Element.DrawObject,Scale.d,Enabled.i = #True) 
     
    Define DrawColour.i,DrawTrans.i
    
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)  
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 
    DrawTrans = Alpha(*Element\Colour)
    
    Define BoxWidth.i = (*Element\X2-*Element\X1)  * Scale
    Define BoxHeight.i = (*Element\Y2-*Element\Y1) * Scale    
    
    VectorSourceColor(DrawColour)
    
    BeginVectorLayer(DrawTrans)
    
    AddPathBox(*Element\X1 * Scale, *Element\Y1 * Scale, BoxWidth, BoxHeight)

    FinishPath(*Element.DrawObject,Scale)
 
    EndVectorLayer()
    
  EndProcedure  
   
  Procedure DrawCircle(*Element.DrawObject,Scale.d,Enabled.i = #True)
        
    Define DrawColour.i,DrawTrans.i
   
    
   If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)     
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf
      
    DrawTrans = Alpha(*Element\Colour)
    
    VectorSourceColor(DrawColour)
    
    BeginVectorLayer(DrawTrans)

    AddPathCircle(*Element\X1 * Scale, *Element\Y1 * Scale, *Element\RadiusX * Scale) 
    
    FinishPath(*Element.DrawObject,Scale)
    
    EndVectorLayer()

  EndProcedure

  Procedure DrawCurve(*Element.DrawObject,Scale.d,Enabled.i = #True)
           
    Define DrawColour.i,DrawTrans.i
    
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)  
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 
    DrawTrans = Alpha(*Element\Colour)
    
    VectorSourceColor(DrawColour)
    
    BeginVectorLayer(DrawTrans)
    
    MovePathCursor(*Element\X1 * Scale, *Element\Y1 * Scale)
    AddPathCurve(*Element\X2 * Scale, *Element\Y2 * Scale, *Element\X3 * Scale, *Element\Y3 * Scale, *Element\X4 * Scale, *Element\Y4 * Scale)

    FinishPath(*Element.DrawObject,Scale)
    
    EndVectorLayer()
     
  EndProcedure

  Procedure DrawEllipse(*Element.DrawObject,Scale.d,Enabled.i = #True)
             
    Define DrawColour.i,DrawTrans.i
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)  
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 
    DrawTrans = Alpha(*Element\Colour)
    
    VectorSourceColor(DrawColour)
    
    BeginVectorLayer(DrawTrans)
    
    ;Element\Rotation
    RotateCoordinates(*Element\X1 * Scale, *Element\Y1 * Scale,*Element\Rotation)    
    
    AddPathEllipse(*Element\X1 * Scale, *Element\Y1 * Scale, *Element\RadiusX * Scale, *Element\RadiusY * Scale)

    FinishPath(*Element.DrawObject,Scale)
    
    EndVectorLayer()
    
  EndProcedure  
  
  Procedure DrawLine(*Element.DrawObject,Scale.d,Enabled.i = #True)

    Define DrawColour.i,DrawTrans.i
    
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)  
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 
    DrawTrans = Alpha(*Element\Colour)
 
    SaveVectorState()

    RotateCoordinates(*Element\RX * Scale, *Element\RY * Scale, *Element\Rotation)

    VectorSourceColor(DrawColour)
    MovePathCursor(*Element\X1 * Scale,*Element\Y1 * Scale)
    AddPathLine(*Element\X2 * Scale,*Element\Y2 * Scale)
    FinishPath(*Element.DrawObject,Scale)
    
    RestoreVectorState()
    
  EndProcedure

  Procedure DrawStar(*Element.DrawObject,Scale.d,Enabled.i=#True)
      
    Define DrawColour.i,DrawTrans.i,Rotate.d
    
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)     
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf
       
    DrawTrans = Alpha(*Element\Colour)
    Rotate = 360/(*Element\Points * 2)
    
    SaveVectorState()
    
    VectorSourceColor(DrawColour)

    RotateCoordinates(*Element\X1 * Scale, *Element\Y1 * Scale, *Element\Rotation)

    MovePathCursor(*Element\X1 * Scale,(*Element\Y1-*Element\RadiusY) * Scale)
    For k = 1 To *Element\Points * 2
      RotateCoordinates(*Element\X1 * Scale, *Element\Y1 * Scale, Rotate)
      If k & 1 = 1
        AddPathLine(*Element\X1 * Scale, (*Element\Y1 - *Element\RadiusX) * Scale)
      Else
        AddPathLine(*Element\X1 * Scale, (*Element\Y1 - *Element\RadiusY) * Scale)
      EndIf
    Next
    ClosePath() 

    FinishPath(*Element.DrawObject,Scale)  
    
    RestoreVectorState()
    
  EndProcedure

  Procedure DrawPolyGon(*Element.DrawObject,Scale.d,Enabled.i=#True)
    
    Define DrawColour.i,DrawTrans.i,Rotate.d
    
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)  
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 
    DrawTrans = Alpha(*Element\Colour)
    
     Rotate = 360/*Element\Points
    
    VectorSourceColor(DrawColour)
    
    BeginVectorLayer(DrawTrans)
    
    ;Element\Rotation
    RotateCoordinates(*Element\X1 * Scale, *Element\Y1 * Scale,*Element\Rotation)
    
    MovePathCursor(*Element\X1 * Scale,(*Element\Y1-*Element\RadiusX) * Scale)
    For k = 1 To *Element\Points - 1
      RotateCoordinates(*Element\X1 * Scale, *Element\Y1 * Scale, Rotate)
      AddPathLine(*Element\X1 * Scale, (*Element\Y1-*Element\RadiusX) * Scale)
    Next
    ClosePath()
       
    FinishPath(*Element.DrawObject,Scale)
     
    EndVectorLayer()
    
  EndProcedure 
  
   Procedure DrawThisText(*Element.DrawObject,Scale.d,Enabled.i=#True)
    
    Define DrawColour.i,DrawTrans.i
    
    If Enabled = #True
      DrawColour = RGBA(Red(*Element\Colour),Green(*Element\Colour),Blue(*Element\Colour),255)  
    Else
      DrawColour = ConvertToGrey(*Element\Colour)
    EndIf 
    DrawTrans = Alpha(*Element\Colour)

    Define VFont.i = LoadFont(#PB_Any, *Element\Font, 8)
    VectorFont(FontID(VFont), *Element\Width * Scale)
    
    Define CentreOffSetX.i = VectorTextWidth(*Element\Text)/2
    Define CentreOffSetY.i = VectorTextHeight(*Element\Text)/2    

    VectorSourceColor(DrawColour)
    
    BeginVectorLayer(DrawTrans)
    RotateCoordinates(*Element\X1 * Scale, *Element\Y1 * Scale, *Element\Rotation)
    
      MovePathCursor( (*Element\X1 * Scale) - CentreOffSetX, (*Element\Y1 * Scale) - CentreOffSetY)
      If *Element\Filled = #True
        DrawVectorText(*Element\Text)
      Else
        AddPathText(*Element\Text)
        StrokePath(1)
      EndIf
      
  ;  FinishPath(*Element.DrawObject) 
      
      
    EndVectorLayer()

  EndProcedure 
 
  Procedure DrawIcon(Size.i,Enabled.i)
    
    Define Scale.d
    
    Scale = Size/128
 
    If NumberOfElements > 0
      
      StartVectorDrawing(CanvasVectorOutput(cnvDraw,#PB_Unit_Pixel))
      VectorSourceColor(RGBA(255,255,255,255))
      FillVectorOutput()
      StopVectorDrawing()
      
      StartVectorDrawing(CanvasVectorOutput(cnvDraw,#PB_Unit_Pixel))
      
      ForEach Elements()
  
        Select Elements()\PathType
 
          Case "Arc"
 
             DrawArc(@Elements(),Scale,Enabled)         
            
          Case "Box"
            
            DrawBox(@Elements(),Scale,Enabled)
          
          Case "Circle"
            
            DrawCircle(@Elements(),Scale,Enabled)
            
          Case "Curve"
            
            DrawCurve(@Elements(),Scale,Enabled)
            
          Case "Ellipse"
            
             DrawEllipse(@Elements(),Scale,Enabled)        
          
           Case "Line"
             
            Drawline(@Elements(),Scale,Enabled)

         Case "Path"
          
            DrawPath(@Elements(),Scale,Enabled)
 
          Case "Poly"
            
            DrawPolyGon(@Elements(),Scale,Enabled)

          Case "Star"
            
           DrawStar(@Elements(),Scale,Enabled)          
    
         Case "Text"
           
           DrawThisText(@Elements(),Scale,Enabled)   

      EndSelect
    Next  
  EndIf

  StopVectorDrawing()  
 
EndProcedure

Procedure.s SelectImage()
  
  Define StartFile.s,FileName.s

  StartFile = GetPathPart(ProgramFilename()) + "Images" + #PS$  ; set initial file+path to display
  File$ = OpenFileRequester("Please choose file to load", StartFile, "Images (*.DVG)|*.DVG", 0)
  If File$
    ProcedureReturn File$
  Else
    ProcedureReturn ""
  EndIf
  
EndProcedure

  winDVG = OpenWindow(#PB_Any, 0, 0, 420, 270, "", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  cnvDraw = CanvasGadget(#PB_Any, 5, 5, 256, 256)
  btnSelect = ButtonGadget(#PB_Any, 270, 10, 140, 30, "Select Image")
  txtScale = TextGadget(#PB_Any, 270, 50, 60, 20, "Scale", #PB_Text_Right)
  strScale = StringGadget(#PB_Any, 350, 50, 60, 20, "128", #PB_String_Numeric)
  chkEnabled = CheckBoxGadget(#PB_Any, 380, 80, 20, 20, "", #PB_CheckBox_Right)
  txtEnabled = TextGadget(#PB_Any, 280, 80, 80, 20, "Enabled", #PB_Text_Right)
  btnExit = ButtonGadget(#PB_Any, 330, 230, 80, 30, "Exit")
  
  SetGadgetState(chkEnabled,#True)
  
  
  Repeat
      
      Event = WaitWindowEvent()
      Select Event
        Case #PB_Event_CloseWindow
          End
  
      Case #PB_Event_Gadget
        Select EventGadget()
            
          Case btnExit
            
            End
            
          Case btnSelect
            
            Size = Val(GetGadgetText(strScale))
            Enabled = GetGadgetState(chkEnabled)
            IconFile = SelectImage()
            If IconFile <> ""
              ReadImageFile(IconFile)
              DrawIcon(Size,Enabled)
            EndIf
            
        EndSelect
    EndSelect
    
    ForEver
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 729
; FirstLine = 71
; Folding = AAA-
; EnableXP